#define GAME_LENGTH 20
#define ROM_LENGTH 20
#define ID_LENGTH 20
#define DESCR_LENGTH 40
#define PATH_LENGTH 256

enum
{
	FULL_COPY,
	ODD_COPY,
	EVEN_COPY,
	BLOCK_FILL,
	COMBINE_ODD,
	COMBINE_EVEN,
	LOWER_COPY,
	LOWER_SHIFT
};

struct Patch
{
	unsigned long address;
	unsigned char value;
};

struct Region
{
	char game[GAME_LENGTH+1];
	char rom[ROM_LENGTH+1];
	unsigned long size;
	unsigned long crc;
	unsigned long offset;
	unsigned long length;
};

struct Rom
{
	int type;
	struct Region local;
	struct Region mame;
	struct Patch *patch;
};

struct Emulator
{
	char id[ID_LENGTH+1];
	char descr[DESCR_LENGTH+1];
	struct Rom *roms;
};

struct Cache
{
	struct Rom *rom;
	char file[PATH_LENGTH+1];
};

/* --- Function prototypes --- */

int find_emulator(char *);
int find_game(char *, char *);
void list_ems();
void list_games(int);
void list_roms(int, int);
void full_list();
void rebuild_roms(int, int, char *, char *);
int scan_dir(char *, struct Cache *rom_cache);
int copy_region(char *, struct Cache *cache);
int combine_region(char *, struct Cache *, struct Cache *);
int combine_region_2(char *, struct Cache *, struct Cache *);
void fill_region(char *, struct Cache *);

